;********************************************
;
; ALGEBRA II PACKAGE - implementation
;
; Version 3.00
;
; by Adam Ziemba
;
; Fortress Productions
; http://home.graffiti.net/fortress_productions
; http://www.myspace.com/fiend666music
; http://www.myspace.com/fiend666
;
; E-mail me at <ahz0123@mail.ecu.edu>
;
;********************************************
; Please view <readme.txt> for documentation
;********************************************
#include "ti83plus.inc"

inRAM   = 0

cursor      EQU $86EC   ; Safe RAM within SaveSScreen
cursorPOS   EQU $86EE
marqStart   EQU $8680
pause       EQU $8683
marqSub     EQU $8684

.org _UserMem

 ld BC,(_curRow)
 push BC
 ld HL,_appBackUpScreen
 B_CALL _SaveDisp   ; Save the display
;---------------------------
; ~~ MAIN MENU ~~
;---------------------------
Begin:
 res donePrgm,(IY+doneFlags)
 set plotLoc,(IY+plotFlags)
 res textWrite,(IY+sGrFlags)
 res fracDrawLFont,(IY+fontFlags) 
 res appTextSave,(IY+appFlags)
 B_CALL _RunIndicOff
 B_CALL _CheckSplitFlag
 jr NZ,skipSplitOvrwrte
 set grfSplitOverride,(IY+sGrFlags)
skipSplitOvrwrte:
 B_CALL _ClrLCD
 call setInv
 xor A
 ld (marqSub+$A0),A
 ld B,A
 ld C,A
 ld HL,txtTitle     ; Display "   ALGEBRA II   "
 call LPut          ; in large inverted text
 call resInv
 ld BC,$0008
 ld DE,$5E08
 ld H,$01
 B_CALL _ILine
 ld BC,$0816        ; Display "by Adam Ziemba"
 ld HL,txtAuthor    ;  in small text
 call SPut
; Display all the MAIN MENU options
 ld BC,$110F
 ld HL,op1_MAIN
 call SPut
 ld A,$31
 ld (cursor),A
 call setInv
 call CPut
 call resInv
 ld BC,$170F
 ld HL,op2_MAIN
 call SPut
 ld HL,op3_MAIN
 call parSPut
 ld HL,op4_MAIN
 call parSPut
 ld HL,op5_MAIN
 call parSPut
 ld HL,op6_MAIN
 call parSPut
 ld HL,$110F
 ld (cursorPOS),HL
 res appAutoScroll,(IY+appFlags)    ; Make sure the screen wont scroll
 res indicOnly,(IY+indicFlags)
 res curAble,(IY+curFlags)
marquee:            ; Start (or restart) the marquee
 ld HL,marqTxt      ; Store location of marqTxt in HL
 ld (marqStart),HL
 ld A,$0B
 ld (pause),A
LOOP:
 B_CALL _GetCSC
 dec A
 jr Z,MENU_Down
 sub $03
 jr Z,MENU_Up
 sub $05
 jp Z,ENTER
 sub $06
 jp Z,Exit
 sub $27
 jp Z,ENTER
 dec A
 jp Z,Exit
return:
 ld A,(pause)
 inc A
 ld (pause),A
 cp $0C
 jr NZ,noMarq
 xor A
 ld (pause),A
 ld HL,(marqStart)  ; Get location of the start of the 16 chars within marqTxt that will become marqSub
 ld BC,$0010
 ld DE,marqSub      ; We want to keep DE the same every time ldir is executed
 ldir               ; Copy 16 characters of marqTxt to marqSub and update position within marqTxt
 ld HL,(marqStart)  ; Restore the original location in HL
 inc HL
 ld (marqStart),HL  ; Move location up one
 ld DE,$0F
 add HL,DE
 xor A
 cp (HL)            ; Is (marqStart+$0F) pointing to the 0-terminated byte in marqTxt?
 jr Z,marquee       ;  if so, restart the marquee
; HL = points to location within marqTxt - increases by $0F each time
; DE = points to location of marqSub
noMarq:
 ld BC,$0007
 ld HL,marqSub
 call LPut          ; Display marqSub at the bottom row, first column in large font
 jr LOOP
MENU_Up:
 ld A,(cursor)      ; Load cursor into A
 call PMENU
 dec A              ; Move cursor up one entry
 cp $30             ; If A=$30, then reset A to last entry
 call Z,RES36
 ld (cursor),A      ; Store new location of cursor
 jr MENU
MENU_Down:
 ld A,(cursor)
 call PMENU
 inc A              ; Move cursor down one entry
 cp $37             ; If A=last entry, then
 call Z,RES31       ;  reset A to $31
 ld (cursor),A
 jr MENU
RES31:
 ld A,$31
 ret
RES36:
 ld A,$36
 ret
ENTER:
; When enter is pressed...
 ld A,(cursor)
 sub $31
 jp Z,LineEquations
 dec A
 jp Z,Logrithms
 dec A
 jp Z,Exponents
 dec A
 jp Z,Functions
 dec A
 jp Z,Trig
 dec A
 jp Z,Domain
PMENU:
 ld BC,(cursorPOS)
 call MENUPut
 ret
MENU:
 push AF
 sub $30    ; Subtract $30 from A
 ld H,A
 ld L,$06
 B_CALL _HTimesL    ; Multiply by $06
 ld A,L
 add A,$0B  ; Add $0B
 ld B,A
 ld C,$0F
 ld (cursorPOS),BC
 pop AF
 call setInv
 call MENUPut   ; Char equate to penY conversion complete!
 call resInv
 jp return
setInv:
 set textInverse,(IY+textFlags)
 ret
resInv:
 res textInverse,(IY+textFlags)
 ret
parSPut:
 ld A,B
 add A,$06
 ld B,A
SPut:
; Precondition:  HL = 0-terminated string
;                B  = Pen Y coordinate
;                C  = Pen X coordinate
; Postcondition: Displays the given string in small font
 ld (_penCol),BC
 B_CALL _VPutS
 ret
LPut:
; Precondition:  HL = 0-terminated string
;                B  = Cursor column
;                C  = Cursor row
; Postcondition: Displays the given string in large font
 ld (_curRow),BC
 B_CALL _PutS
 ret
MENUPut:        ; Used to set pen X to 16
 ld C,$0F       ;  before calling CPut
CPut:
; Precondition:  A = Character font equate
;                B = Pen Y coordinate
;                C = Pen X coordinate
; Postcondition: Displays the corresponding character in small font, followed by a colon ':'
 ld (_penCol),BC
 push AF
 B_CALL _VPutMap
 ld A,C
 add A,$04
 ld C,A
 ld (_penCol),BC
 ld A,$3A
 B_CALL _VPutMap
 pop AF
 ret
LineEquations:
 ld HL,LINE
 jr exePrgm
Logrithms:
 ld HL,LOG
 jr exePrgm
Exponents:
 ld HL,EXP
 jr exePrgm
Functions:
 ld HL,FUNC
 jr exePrgm
Trig:
 ld HL,TRIG
 jr exePrgm
Domain:
 ld HL,DOMAIN
exePrgm:
; Precondition:  HL = name of program to run.
; Postcondition: If the program exists, it is executed, otherwise the user is notified.
;                Errors, if present, are handled accordingly.
 push HL
 B_CALL _Mov9ToOP1      ; OP1 = (HL)
 B_CALL _ChkFindSym     ; Look to see if prgm exists
 jp C,noexist           ; If not, goto noexist
 and $1F                ; Get data type of the prgm
 cp ProtProgObj         ; Is the prgm protected?
 jr NZ,noexist          ;  if not, than it can't be my program, so goto noexist
 ld A,B
 or A                   ; Is the prgm archived?
 call NZ,unArchive      ;  if so, unarchive it
 AppOnErr(ErrHandler)   ; This is how my assembler uses macros
 B_CALL _PushOP1        ; Save OP1 (this is saved on the FP stack, not SP stack)
 set appTextSave,(IY+appFlags)
 set progExecuting,(IY+newDispF)    ; This flag must be set
 B_CALL _ParseInp       ; Execute the prgm
 res progExecuting,(IY+newDispF)    ; Must reset this after execution is done
 res appTextSave,(IY+appFlags)
 B_CALL _PopOP1         ; Restore OP1
 AppOffErr              ; Turn off error handler
 call unArchive
 pop HL
 jp Begin
ErrHandler:
; A = system error code
 res progExecuting,(IY+newDispF)    ; Must reset this after execution is done
 cp E_MEMORY    ; If error memory,
 jr Z,ErrMem    ;  goto ErrMem
 cp E_BREAK
 ret NZ
back:
 res progExecuting,(IY+newDispF)
 res onInterrupt,(IY+onFlags)
 pop HL
 jp Begin
ErrMem:
 ld HL,$130C
 ld DE,$2D52
 B_CALL _DrawRectBorderClear
 ld BC,$140E
 ld HL,err_mem1
 call SPut          ; Display "ERROR: insufficient"
 ld HL,err_mem2
 call parSPut       ; Display "memory to execute"
 ld B,$26
 ld HL,err_mem4
 call parSPut       ; Display "up space & try again."
 ld BC,$2040
 ld HL,err_mem3
 call SPut          ; Display ".Free"
 ld C,$1C
 jr wait
noexist:
 ld HL,$140A
 ld DE,$2A57
 B_CALL _DrawRectBorderClear
 call SPut          ; Display prgm name
 ld BC,$150C
 ld HL,err_nonex1
 call SPut          ; Display "prgm"
; ld B,$1C
 ld HL,err_nonex2
 call parSPut
; ld B,$23
 ld HL,err_nonex3
 call parSPut
 ld BC,$1531
wait:
 pop HL
 call SPut          ; Display prgm name
 ld A,C
 sub $0E
 ld C,A
 ld HL,prgm
 call SPut
 ld HL,$0007
 ld (_curRow),HL
 B_CALL _EraseEOL   ; Clear out the last curRow
 ld BC,$390F
 ld HL,err_nonex4
 call SPut          ; Display "Press any key to Quit"
 B_CALL _GetKey
 jp Begin
unArchive:
 B_CALL _OP1ToOP6
 B_CALL _Arc_Unarc
 B_CALL _OP6ToOP1
 ret
Exit:
; B_CALL _ClrLCD
 ld HL,_appBackUpScreen
 ld B,$40
 B_CALL _RestoreDisp
 set appAutoScroll,(IY+appFlags)
 res grfSplitOverride,(IY+sGrFlags)
 pop BC
 ld (_curRow),BC
; set appTextSave,(IY+appFlags)
 B_CALL _Disp
 ret
;---------------------------
; ~~ STRINGS / CONSTANTS ~~
;---------------------------
txtTitle:   .db "   ALGEBRA II   ",0
txtAuthor:  .db "by Adam Ziemba",0
op1_MAIN:   .db "1: Line Equations",0
op2_MAIN:   .db "2: Logrithms",0
op3_MAIN:   .db "3: Exponents",0
op4_MAIN:   .db "4: Functions",0
op5_MAIN:   .db "5: Trigonometry",0
op6_MAIN:   .db "6: Domain ",$26," Range",0
marqTxt:    .db "                Algebra II Package - Version 3.0 - by Adam Ziemba - You may use these programs freely, but I can not be held responsible if you are caught using them illicitly.                ",0
LINE:       .db ProtProgObj,"LINEEQU",0
LOG:        .db ProtProgObj,"LOGRITHM",0
EXP:        .db ProtProgObj,"EXPONENT",0
FUNC:       .db ProtProgObj,"FUNCTION",0
TRIG:       .db ProtProgObj,"TRIG",0
DOMAIN:     .db ProtProgObj,"DOMAIN",0
err_nonex1: .db "ERROR:",0
err_nonex2: .db "does not exist! Ungroup",0
err_nonex3: .db "'ALGEBRA2' to get it.",0
err_nonex4: .db "Press any Key to Exit",0
err_mem1:   .db "ERROR: insufficient",0
err_mem2:   .db "memory to execute",0
err_mem3:   .db ".Free",0
err_mem4:   .db "up space ",$26," try again.",0
prgm:       .db "prgm",0

.end